-- Author      : Noxis
-- Create Date : 11/1/2021 12:20:35 PM
local AddonName, Private = ...

RaidtoolExport = LibStub("AceAddon-3.0"):NewAddon("RaidtoolExport", "AceConsole-3.0", "AceEvent-3.0", "AceComm-3.0");

RTLang = LibStub("AceLocale-3.0"):GetLocale("RaidtoolExport")

local AceGUI = LibStub("AceGUI-3.0")
local RaidtoolExport_minimapicon = LibStub("LibDBIcon-1.0")
local RaidtoolFrame
local RaidtoolsDB
local isWindowShown = false
local icon = LibStub("LibDBIcon-1.0")
local EventFrame = CreateFrame("frame", "EventFrame")
local playerName = UnitName("player")
local isInit = false

GuildProfessions = {}
CRE_GuildRoster = {}
Engineering = {}
Leatherworking = {}
Blacksmithing = {}
Tailoring = {}
Enchanting = {}
Alchemy = {}
Jewelcrafting = {}
Cooking = {}

local RaidtoolExport_ldb = LibStub("LibDataBroker-1.1"):NewDataObject("Raidtools_Broker", {
		type = "data source",
		label = "Raidtool Tradeskill Overview",
		text = "Click me!",
		icon = "Interface\\Icons\\inv_hammer_03",
		OnClick = function(_, button) -- fires when a user clicks on the minimap icon
			if button == "RightButton" then
				-- does the same thing as typing '/tsm config'
				RaidtoolExport:CommandHelper("")
			elseif button == "LeftButton" then
				-- does the same thing as typing '/tsm'
				RaidtoolExport:CommandHelper("")
			end
		end,
				OnTooltipShow = function(tooltip)
			tooltip:AddLine("|cFFffffffRaidtool Export |r")

			tooltip:AddLine(" ")
			tooltip:AddLine("|cffffd100".."click to open!", 0.2, 1, 0.2)
		end,
	})



function RaidtoolExport:OnInitialize()
		-- Called when the addon is loaded
		 self.db = LibStub("AceDB-3.0"):New("RaidtoolsDB")
		 icon:Register("Raidtools_Broker", RaidtoolExport_ldb, RaidtoolsDB)
		-- Print a message to the chat frame
		self:Print("OnInitialize Event Fired: Raidtool Export loaded...")
end

function RaidtoolExport:OnLoaded()

end

function RaidtoolExport:OnDisable()
		-- Called when the addon is disabled
end


EventFrame:SetScript("OnEvent", function(self, event, ...)
	if(event == "GUILD_ROSTER_UPDATE") then
		CreateGRTable()
	end
	if(event == "TRADE_SKILL_UPDATE") then
		CreateTSTable()
	end
	if(event == "CRAFT_SHOW") then
		CreateCRTable()
	end
end)
EventFrame:RegisterEvent("GUILD_ROSTER_UPDATE")
EventFrame:RegisterEvent("TRADE_SKILL_UPDATE")
EventFrame:RegisterEvent("CRAFT_SHOW")

function CreateGRTable()
	wipe(CRE_GuildRoster)
	server = GetRealmName();
	numTotal = GetNumGuildMembers();
	for i = 1, numTotal do
		name, rank, rankIndex, level, class, zone, note, officernote, online, status, classFileName, achievementPoints, achievementRank, isMobile, isSoREligible, standingID = GetGuildRosterInfo(i)
	tinsert(CRE_GuildRoster, i, {Player = Split(name, "-")[1], Level = level, Guild = guildName, Class = class, Note = officernote, Server = server})
	end
end

function CreateTSTable()
tsName, tsRank, _ = GetTradeSkillLine()
	if(tsRank > 0) then
		if(tsName == "Ingenieurskunst" or tsName == "Engineering") then
			wipe(Engineering)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Engineering,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end
		end
		if(tsName == "Lederverarbeitung" or tsName == "Leatherworking") then
			wipe(Leatherworking)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Leatherworking,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end
		end
		if(tsName == "Schmiedekunst" or tsName == "Blacksmithing") then
			wipe(Blacksmithing)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Blacksmithing,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end		
		end
		if(tsName == "Schneiderei" or tsName == "Tailoring") then
			wipe(Tailoring)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Tailoring,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end		
		end
		if(tsName == "Alchemie" or tsName == "Alchemy") then
			wipe(Alchemy)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Alchemy,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end		
		end
		if(tsName == "Juwelierskunst" or tsName == "Jewelcrafting") then
			wipe(Jewelcrafting)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Jewelcrafting,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end		
		end
		if(tsName == "Kochkunst" or tsName == "Cooking") then
			wipe(Cooking)
			for d = 1,GetNumTradeSkills() do
				skillName, skillType, numAvailable, isExpanded, altVerb, numSkillUps = GetTradeSkillInfo(d)
				if (skillName and skillType ~= "header") then
					local tradeID = getItemIdCore("trade", d)
					tinsert(Cooking,{Player = playerName, Craft = tsName, ID = tradeID})
				end
			end
		end
	end
end

function CreateCRTable()
local craftName, craftRank, _ = GetCraftDisplaySkillLine()
	if(craftRank > 0 and craftName == "Enchanting" or craftName == "Verzauberungskunst") then
	wipe(Enchanting)
		for e = 1,GetNumCrafts() do
			tradeskillName, craftSubSpellName, craftType, numAvailable, isExpanded, trainingPointCost, requiredLevel = GetCraftInfo(e)
			if (tradeskillName and craftType ~= "header") then
				local craftID = getItemIdCore("craft", e)
				tinsert(Enchanting,{Player = playerName, Craft = craftName, ID = craftID})
			end
		end
	end
end

function Split(s, delimiter)
    result = {};
    for match in (s..delimiter):gmatch("(.-)"..delimiter) do
        table.insert(result, match);
    end
    return result;
end

function getItemIdCore(prof_type, index)
  local itemLink, itemID
  if (prof_type == "trade") then
    itemLink = GetTradeSkillItemLink(index)
    if (not itemLink) then return end
    itemID = itemLink:match("item:(%d+)")
  elseif (prof_type == "craft") then
    itemLink = GetCraftItemLink(index)
    if (not itemLink) then return end
    itemID = itemLink:match("enchant:(%d+)")
  end

  return tonumber(itemID)

end



RaidtoolExport:RegisterChatCommand("rte", "CommandHelper")

function RaidtoolExport:CommandHelper(msg)
	if msg == "help" then
		print("Raidtool Export - Help")
		print("Type '/rte' to open the guild overview")
		print("Type '/rte help' to view this message")
	elseif isWindowShown then
		RaidtoolFrame:Hide()
		RaidtoolFrame:Release()
	elseif isInit == false then
		isInit = true
		MainFrame()
	else
		MainFrame()
	end
end

local tree = { 
	{ 
	  value = "Schneiderei",
	  text = RTLang[" Tailoring"],
	  icon = "interface/icons/trade_tailoring.blp",
	},
	{ 
		value = 2,
		text = RTLang[" Blacksmithing"],
		icon = "interface/icons/trade_blacksmithing.blp",
	  },
	  { 
		value = 3,
		text = RTLang[" Jewelcrafting"],
		icon = "interface/icons/inv_misc_gem_02.blp",
	  },
	  { 
		value = 4,
		text = RTLang[" Leatherworking"],
		icon = "interface/icons/trade_leatherworking.blp",
	  },
	  { 
		value = 5,
		text = RTLang[" Alchemy"],
		icon = "interface/icons/trade_alchemy.blp",
	  },
	  { 
		value = 6,
		text = RTLang[" Engineering"],
		icon = "interface/icons/trade_engineering.blp",
	  },
	  { 
		value = 7,
		text = RTLang[" Enchanting"],
		icon = "interface/icons/trade_engraving.blp",
	  },
	  { 
		value = 8,
		text = RTLang[" Cooking"],
		icon = "interface/icons/trade_engraving.blp",
	  }
}
local ScrollFrameChild
local ChildFrame 

function Tradeskill_Select(tradeskill)
	PlaySound(856)  
	local scrollframe = ScrollFrameChild.content.obj.content
	local LoadedData = {}
	ScrollFrameChild:ReleaseChildren()
	
	if tradeskill == "Schneiderei" then
		for key, value in pairs(GuildProfessions) do
			for key, value in pairs(GuildProfessions) do
			end
		end
	end

end


function MainFrame()

	if isWindowShown then
		return
	else
		isWindowShown = true
	end
	
	RaidtoolFrame = AceGUI:Create("Frame", "RaidToolMainFrame")
	RaidtoolFrame:SetTitle(RTLang["Raidtool Professions Overview"])
	RaidtoolFrame:SetCallback("OnClose", function(widget) AceGUI:Release(widget)
		isWindowShown = false
	end)
	RaidtoolFrame:SetHeight(550)
	RaidtoolFrame:SetWidth(1010)
	-- frametest:SetLayout("Flow")	
	RaidtoolFrame.frame:SetMinResize(1010, 550)
	RaidtoolFrame.frame:SetFrameStrata("HIGH")

	RaidtoolFrame:SetLayout("Fill")

	-- Create the TabGroup
	ScrollFrameChild = AceGUI:Create("TreeGroup")
	ScrollFrameChild:SetLayout("Flow")
	ScrollFrameChild:SetTree(tree)
	ScrollFrameChild:SetCallback("OnGroupSelected", function(container, event, selection)
				--get actual attune (remove expac/group)
				expac, group, sel = strsplit("\001", selection);
				if sel ~= "" and sel ~= nil then
					Tradeskill_Select(sel)
				end
	end)


	ChildFrame =  AceGUI:Create("SimpleGroup")
	ChildFrame:SetLayout("Flow")

	-- add to the frame container
	RaidtoolFrame:AddChild(ScrollFrameChild)
	RaidtoolFrame:AddChild(ChildFrame)

	_G["RaidtoolExport_MainFrame"] = RaidtoolFrame.frame
	tinsert(UISpecialFrames, "RaidtoolExport_MainFrame")
end